﻿using System;
using System.Linq;
using System.Windows.Media;
using Styx;
using Styx.Common;
using Styx.Plugins;
using Styx.WoWInternals.WoWObjects;

namespace StoutAugmentRune {
    public class StoutAugmentRunePlugin : HBPlugin {

        // ===========================================================
        // Constants
        // ===========================================================

        // ===========================================================
        // Fields
        // ===========================================================

        public static LocalPlayer Me = StyxWoW.Me;

        public static WoWItem StoutAugmentRuneItem;

        // ===========================================================
        // Constructors
        // ===========================================================

        // ===========================================================
        // Getter & Setter
        // ===========================================================

        // ===========================================================
        // Methods for/from SuperClass/Interfaces
        // ===========================================================

        public override string Name {
            get { return "Stout Augment Rune"; }
        }

        public override string Author {
            get { return "Morgrel"; }
        }

        public override Version Version {
            get { return new Version(1, 0); }
        }


        public override void Pulse() {
            if(!HasStoutAugmentRuneItem()) {
                return;
            }

            if(!CanUseStoutAugmentRune()) {
                return;
            }

            if(HasStoutAugmentRuneBuff()) {
                return;
            }

            if(IsStoutAugmentRuneOnCooldown()) {
                return;
            }

            UseStoutAugmentRune();

            CustomNormalLog("Stout Augment Rune buff is now active.");
        }

        // ===========================================================
        // Methods
        // ===========================================================

        public void CustomNormalLog(string message, params object[] args) {
            Logging.Write(Colors.DeepSkyBlue, "[Stout Augment Rune]: " + message, args);
        }

        public static bool IsViable(WoWObject pWoWObject) {
            return (pWoWObject != null) && pWoWObject.IsValid;
        }

        public static bool HasStoutAugmentRuneItem() {
            StoutAugmentRuneItem = Me.BagItems.FirstOrDefault(item => item.Entry == 118631);

            return StoutAugmentRuneItem != null;
        }

        public static bool CanUseStoutAugmentRune() {
            return IsViable(Me) && !Me.Mounted && !Me.IsDead && !Me.InVehicle && !Me.IsChanneling && !Me.IsFlying && !Me.IsCasting && !Me.OnTaxi;
        }

        public static bool HasStoutAugmentRuneBuff() {
            return Me.HasAura(175439);
        }

        public static void UseStoutAugmentRune() {
            StoutAugmentRuneItem.Use();
        }

        public static bool IsStoutAugmentRuneOnCooldown() {
            return StoutAugmentRuneItem.Cooldown > 0;
        }

        // ===========================================================
        // Inner and Anonymous Classes
        // ===========================================================


    }
}